// Arne Maus' simple expression grammar example, formulated in Antlr.
header {
    import antlr.collections.AST;
}

/** Simple exp parser with AST node generation. */
class SimpleExpWithASTParser extends Parser;

options {
    // Necessary to share the token vocabulary of the resused scanner
    // (from SimpleExp.g).
    importVocab = SimpleExpLexer; 
    buildAST = true;
}

{ 
    public static void main(String args[]) throws Exception {
        final SimpleExpWithASTParser parser = 
            new SimpleExpWithASTParser(new SimpleExpLexer(System.in));
        parser.exp();
        final AST t = parser.getAST();
        System.out.println(t.toStringTree());
    }
}

exp : NUMBER^ ((("+"^ | "-"^) NUMBER))*
            EOF!
    ;

